//ATmega8
//F_CPU=8Mhz
#include <avr/io.h>
#include <avr/interrupt.h>

#define d0   0 //  
#define d1   1 // 
#define d2   2 // 
#define menu 3 //  ""
#define inc  4 //  "+"
#define dec  5 //  "-"
#define Rele 6

#define ROWS PORTB /*    */
#define COLS PORTD /*    */

#define SKIP_BY_KEY 200; //  ,
                         //   200 
#define SKIP_BY_LED 8;   //  ,
                         //   8
#define SKIP_BY_REF 1000;//     

volatile unsigned int max=240; // 
volatile unsigned int min=180; //


volatile unsigned char ByDisplay[3];//  
volatile unsigned char bufkey=0; // (   )
volatile unsigned char inx=0;   //  -    

volatile unsigned int  DataForLed=0; //   ,  
//  
volatile const  char byCharacter[11]={ 0x3F,0x06,0x5B,0x4F,0x66,0x6D,0x7D,0x07,0x7F,0x6F,0x00,};

// *****************  *******************************

//    ()
//____________________________________________________
void Decoder(unsigned int DataForLed) 
{
unsigned char Num1, Num2, Num3;
  Num1=Num2=0;
  while (DataForLed  >= 100)  
	  {
	    DataForLed -= 100;  
	    Num1++;  
	  }
      while (DataForLed  >= 10) 
		  {
		    DataForLed  -= 10;  
		    Num2++; 
		  }
           Num3 = DataForLed ;
  ByDisplay[0] =Num1;
  ByDisplay[1] =Num2;
  ByDisplay[2] =Num3;

}
//___________________________________________________

//  (  200)
//___________________________________________________
void Scan(void)
{
 static unsigned char skip_by_key = SKIP_BY_KEY;
if (--skip_by_key) return; 
 skip_by_key = SKIP_BY_KEY;
 if (!(PIND&(1<<menu))) //  ""
      {
	    bufkey|=1<<menu; //    .
	  }		  
 if (!(PIND&(1<<inc))) //  "+" 
      {
		bufkey|=1<<inc; //    
	  }		 
 if (!(PIND&(1<<dec))) //  "-"  
      {
		bufkey|=1<<dec; //    
	  }
}

// 
//___________________________________________________
void Indic(void)
{
volatile static unsigned char skip_by_led = SKIP_BY_LED;
static unsigned char pos = 0;
if (--skip_by_led) return;
 skip_by_led = SKIP_BY_LED;
 COLS &=~ (1<<d0); 
 COLS &=~ (1<<d1);
 COLS &=~ (1<<d2);
 ROWS=byCharacter[ByDisplay[pos]];
 COLS|= (1<<pos);
 if(++pos == 3) pos = 0;
}
//___________________________________________________

//  ,   
//___________________________________________________
void ReadBuf(void)
{
 if (bufkey&(1<<menu))
      {
	  ++inx;
	     switch(inx)
		   {
		    case 1:DataForLed=max; bufkey&=~(1<<menu); break; //indic Umax
			case 2:DataForLed=min; bufkey&=~(1<<menu); break; //indic Umin
			case 3:DataForLed=max; bufkey&=~(1<<menu); break; 	
			case 4:DataForLed=min; bufkey&=~(1<<menu); break;// DataForLed //edit Umin
			case 5:DataForLed=0; inx=0; bufkey&=~(1<<menu); break; //save and exit 
		   }
      }

 if ((bufkey&(1<<inc))&&((inx==3)||(inx==4)))
      {
	  switch(inx)
	    {
		case 0:break;
		case 1:break;
		case 2:break;
		case 3:if(++max>260) {max=230;} bufkey&=~(1<<inc); break;       
		case 4:if(++min>220) {min=180;} bufkey&=~(1<<inc); break;
	    case 5:break;
		}
       }

 if ((bufkey&(1<<dec))&&((inx==3)||(inx==4)))
      {
	  switch(inx)
	    {
		case 0:break;
		case 1:break;
		case 2:break;
		case 3:if(--max<230) {max=260;} bufkey&=~(1<<dec); break;       
		case 4:if(--min<180) {min=220;} bufkey&=~(1<<dec); break;
	    case 5: bufkey&=~(1<<dec); break;
		}
      }
}


// 
//_____________________________________________________
inline void init(void) 
{
 DDRD=(1<<d0)|(1<<d1)|(1<<d2)|(!(1<<menu))|(!(1<<inc))|(!(1<<dec))|(1<<Rele);
 PORTD|=((1<<menu)|(1<<inc)|(1<<dec)); // .   
 DDRB=0xFF;
 TIMSK=1<<OCIE1A;
 OCR1AL=125;
 TCCR1B =(1<<WGM12)|(1<<CS11)|(1<<CS10); //64
 TCNT1H=0x00 ;  
 TCNT1L=0x00 ;  
 sei();
}
//__________________________________________________

//***************************************************

//    1
ISR(TIMER1_COMPA_vect) // 1ms
{	
 Indic();//  8 
 Scan(); //  200
 
 static unsigned int skip_by_ref = SKIP_BY_REF; //
if (--skip_by_ref) return;                      //""
 skip_by_ref = SKIP_BY_REF;                     // 1000
  Decoder(DataForLed);
}
 
// 
int main(void)
{
 init();	
	while(1)
	{
	 ReadBuf();
	}
}
